using Distances

function covSEard(X, X2, v, l; p=0)
    N = size(X,1)
    N2 = size(X2,1)
    D = size(X,2)
    assert(size(l,2) == 1)
    ell = exp(l')
    sf2 = exp(2*v)
    X = diagm(1./ell[:]) * X'
	X2 = diagm(1./ell[:]) * X2'
    #K = zeros(N,N2)
    #for i=1:N
    #    for j=1:N2
    #        #K[i,j] = v * exp(-0.5 * sum((X[i,:] - X2[j,:]).^2 * l))
    #        #K[i,j] = sf2 * exp((-0.5 * sum((X[i,:] - X2[j,:]).^2)))
    #        K[i,j] = sum((X[:,i] - X2[:,j]).^2)
    #    end
    #end
    K = pairwise(SqEuclidean(), X, X2)
    K = sf2*exp(-K/2)

    # derivatives
    if p > 0 
    	# compute derivatives of cov function wrt to ith parameter
    	if p <= D # length scale parameter
	        #sq_dist = zeros(N,N2)
		    #for i=1:N
		    #    for j=1:N2
		    #        sq_dist[i,j] = sum((X[p,i] - X2[p,j]).^2)
		    #    end
		    #end
            sq_dist = pairwise(SqEuclidean(), X[p:p,:], X2[p:p,:])
            dK = K.*sq_dist
		else # magnitude parameter
			dK = 2*K
		end
		return dK
    else
    	return K
    end
end